<?php
if (!class_exists('ecologram')) {

    class ecologram {

        //Params
        public $config;
        public $version;
        public $server_name;
        public $server_protocol;
        //Cache stuff
        public $users_cache;
        public $users_cache_id;
        //Sessions stuff
        public $session;
        public $title;
        public $template;
        public $templates;
        public $lang;
        //Networks
        public $networks;
        public $networks_path;

        function ecologram() {
            session_name('3col0Gr4m');
            session_start();
            $this->version = '3.5.0';

            $this->title = 'Slide Your Net';
            $this->template = 'main';
            $this->session = false;
            $this->templates = array(
                'slide',
                'stream',
                'pix',
                'live'
            );

            if (!defined('ABS_PATH'))
                define('ABS_PATH', dirname(__FILE__) . '/');
            global $conf, $conn;
            $conf = array();

            require ABS_PATH . 'config.php';
            require ABS_PATH . 'includes/gettext.php';
            require ABS_PATH . 'includes/utils.php';
            require ABS_PATH . 'includes/snapshot.php';

            $this->messages = require ABS_PATH . 'includes/messages.php';

            $conn = mysqli_connect($conf['db_host'], $conf['db_user'], $conf['db_pass']);
            $this->mysqli = $conn;
            mysqli_select_db($this->mysqli, $conf['db_base']);

            $this->users_cache = array();
            $this->config = $conf;
            date_default_timezone_set($conf['timezone']);

            $this->server_name = isset($conf['server_name']) && !empty($conf['server_name']) ? $conf['server_name'] : $_SERVER['SERVER_NAME'];
            $this->server_protocol = isset($conf['server_protocol']) && !empty($conf['server_protocol']) ? $conf['server_protocol'] : 'http';

            $this->networks_path = ABS_PATH . 'includes/networks/';

            $this->base_url = 'http://' . $_SERVER['SERVER_NAME'] . '/';
            $this->admin_url = 'http://' . $_SERVER['SERVER_NAME'] . '/admin/';

            $this->current_url = 'http://' . $_SERVER['SERVER_NAME'] . '/' . $_SERVER['SCRIPT_NAME'];
            $this->current_url_query = 'http://' . $_SERVER['SERVER_NAME'] . '/' . $_SERVER['SCRIPT_NAME'] . '?' . $_SERVER['QUERY_STRING'];

            //Networks
            $this->networks = array();
            $available_networks = scandir($this->networks_path);
            foreach ($available_networks as $network) {
                if (is_file($this->networks_path . $network . '/settings.json')) {
                    $this->networks[$network] = array(
                        'active' => 0,
                        'status' => 0,
                        'settings' => json_decode(file_get_contents($this->networks_path . $network . '/settings.json'))
                    );
                }
            }
            $this->load_networks();
            if (!$this->is_admin()) {
                $this->front_post();
            }

            $lang = isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) ? $_SERVER['HTTP_ACCEPT_LANGUAGE'] : 'fr';
            $lang = explode(',', $lang);
            $prefered_lang = $lang[0];
            if (strlen($prefered_lang) == 2) {
                $prefered_lang = strtolower($prefered_lang) . '_' . strtoupper($prefered_lang);
            }
            set_language($prefered_lang);
        }

        function is_admin() {
            return basename(dirname(__FILE__)) == 'admin';
        }

        function db_where() {
            if (!$this->session)
                return '';

            return "`session_id`='" . $this->session->id . "' AND";
        }

        function check_token() {
            if (isset($_REQUEST['s']) && isset($_REQUEST['t'])) {
                $req = "SELECT
                *
            FROM
                `" . $this->config['db_prefix'] . "sessions`
            WHERE
                `name`='" . addslashes($_REQUEST['s']) . "'
                AND `token`='" . addslashes($_REQUEST['t']) . "' ";
                if (false !== ($res = mysqli_query($this->mysqli, $req)) && mysqli_num_rows($res) == 1) {
                    $this->session = mysqli_fetch_object($res);
                    $this->lang = $this->session->lang;
                    $this->load_networks();
                    set_language($this->lang);
                    return true;
                }
            }
            _e('Bad link');
            exit;
        }

        /*
         * set_session
         * Force to modify current session without token
         *
         * @param $session_name
         *
         * @return bool
         *
         */

        function set_session($session_name) {
            $req = "SELECT
                *
            FROM
                `" . $this->config['db_prefix'] . "sessions`
            WHERE
                `name`='" . addslashes($session_name) . "'";
            if (false !== ($res = mysqli_query($this->mysqli, $req)) && mysqli_num_rows($res) == 1) {
                $this->session = mysqli_fetch_object($res);
                $this->load_networks();
                return true;
            }
            return false;
        }

        /*
         * list_sessions
         * @param $parameters (array)
         * 	*	@param active (bool)
         * 	*	@param return (array of columns to get, default=name)
         *
         *
         * @return an arrray of sessions
         *
         */

        function list_sessions($params = array()) {

            $where = '';
            $what = '`name`';
            $custom_what = false;
            if (isset($params['active'])) {
                $now = date('Y-m-d H:i:s');
                if ($params['active'] == true) {
                    $where.="AND
					(`date_begin`='0000-00-00 00:00:00' OR `date_begin`<='" . $now . "')
					AND
					(`date_end`='0000-00-00 00:00:00' OR `date_end`>='" . $now . "')
				";
                } elseif ($params['active'] == false) {
                    $where.="AND (
						(`date_begin`!='0000-00-00 00:00:00' AND `date_begin`>='" . $now . "')
						OR
						(`date_end`!='0000-00-00 00:00:00' OR `date_end`<='" . $now . "')
					)
				";
                }
            }
            if (isset($params['name']) && !empty($params['name'])) {
                $where.="AND
					`name`='" . addslashes($params['name']) . "'";
            }
            if (isset($params['return']) && is_array($params['return']) && sizeof($params['return']) > 0) {
                $what = '';
                foreach ($params['return'] as $return) {
                    $what.='`' . $return . '`,';
                }
                $what = substr($what, -1);
                $custom_what = true;
            }

            $sessions = array();
            $req = "SELECT
                " . $what . "
            FROM
                `" . $this->config['db_prefix'] . "sessions`
            WHERE
                1 " . $where;
            if (false !== ($res = mysqli_query($this->mysqli, $req)) && mysqli_num_rows($res) > 0) {
                while ($session = mysqli_fetch_object($res)) {
                    if ($custom_what == true)
                        $sessions[] = $session;
                    else
                        $sessions[] = $session->name;
                }
            }
            return $sessions;
        }

        function load_networks() {
            if (!$this->session)
                return '';

            foreach ($this->networks as $network => $attributes) {
                $req = "SELECT `status`,`preferences` FROM `" . $this->config['db_prefix'] . "networks` WHERE " . $this->db_where() . " `name`='" . $network . "'";
                $res = mysqli_query($this->mysqli, $req);
                if ($res && mysqli_num_rows($res) > 0) {
                    $preferences = mysqli_fetch_array($res);
                    $this->networks[$network]['active'] = 1;
                    $this->networks[$network]['status'] = $preferences[0];
                    $this->networks[$network]['options'] = unserialize($preferences[1]);
                }
            }
        }

        function front_post() {
            if (!isset($_POST))
                return;

            if (isset($_POST['action'])) {
                switch ($_POST['action']) {
                    case 'create':

                        if (!is_post('name')) {
                            redirect($this->current_url . '?message[]=1');
                        } else {
                            $name = str_replace(array('/', '?', '&', "'", '"'), '', strtolower(stripslashes($_POST['name'])));
                            $check_existing = $this->list_sessions(array('name' => $name));
                            if (sizeof($check_existing) > 0) {
                                redirect($this->current_url . '?message[]=2');
                            }

                            $token = md5(time());
                            $req = "INSERT INTO `" . $this->config['db_prefix'] . "sessions` (`name`,`token`) VALUES ('" . $name . "','" . $token . "')";
                            if (mysqli_query($this->mysqli, $req)) {
                                redirect($this->admin_url . '?s=' . $name . '&t=' . $token);
                            }

                            //redirect($this->current_url.'?message[]=0');
                        }
                        break;
                }
            }
        }

        function admin_post() {
            if (!isset($_POST))
                return;


            if (isset($_POST['session']['mod'])) {
                $req = "UPDATE `" . $this->config['db_prefix'] . "sessions` SET "
                        . " `mod`='" . abs($_POST['session']['mod']) . "',"
                        . "`snapshot`='" . abs($_POST['session']['snapshot']) . "', "
                        . "`duplicate`='" . abs($_POST['session']['duplicate']) . "' "
                        . "WHERE `id`='" . $this->session->id . "'";
                if (mysqli_query($this->mysqli, $req)) {
                    $this->session->mod = $_POST['session']['mod'];
                    $this->session->snapshot = $_POST['session']['snapshot'];
                }
            }
            foreach ($this->networks as $network => $attributes) {
                if (isset($_POST['networks'][$network])) {
                    $status = isset($_POST['networks_status'][$network]) ? 1 : 0;
                    $options = serialize($_POST['networks'][$network]);
                    if ($attributes['active'] == 1) {
                        $req = "UPDATE `" . $this->config['db_prefix'] . "networks` SET `status`='" . $status . "', `preferences`='" . $options . "' WHERE " . $this->db_where() . " `name`='" . $network . "'";
                    } else {
                        $req = "INSERT INTO `" . $this->config['db_prefix'] . "networks` (`session_id`,`name`,`status`,`preferences`) VALUES ('" . $this->session->id . "','" . $network . "','" . $status . "','" . $options . "') ";
                    }

                    if (mysqli_query($this->mysqli, $req)) {
                        $this->networks[$network]['status'] = $status;
                        $this->networks[$network]['options'] = unserialize(stripcslashes($options));
                    }
                }
            }
        }

        function print_messages() {
            if (is_request('message')) {
                if (is_numeric($_REQUEST['message']) && isset($this->messages[$_REQUEST['message']])) {
                    echo '<span class="eg_alert ' . $this->messages[$_REQUEST['message']]['class'] . '">' . $this->messages[$_REQUEST['message']]['text'] . '</span>';
                } elseif (is_array($_REQUEST['message'])) {
                    foreach ($_REQUEST['message'] as $message_id) {
                        if (isset($this->messages[$message_id])) {
                            echo '<span class="eg_alert ' . $this->messages[$message_id]['class'] . '">' . $this->messages[$message_id]['text'] . '</span>';
                        }
                    }
                }
            }
        }

        /** Users * */
        function get_user($username, $network = '', $user_avatar = '', $user_description = '', $user_city = '') {
            if (!$this->session)
                return false;

            //echo $username.' / '.$network.' / '.$user_avatar."\n\n";
            if (is_array($username)) {
                $user_array = $username;
                $username = isset($user_array['username']) ? $user_array['username'] : '';
                $network = isset($user_array['network']) ? $user_array['network'] : '';
                $user_avatar = isset($user_array['user_avatar']) ? $user_array['user_avatar'] : '';
                $user_description = isset($user_array['user_description']) ? $user_array['user_description'] : '';
                $user_city = isset($user_array['user_city']) ? $user_array['user_city'] : '';
            } else {
                $user_array = array(
                    'username' => $username,
                    'network' => $network,
                    'user_avatar' => $user_avatar,
                    'user_description' => $user_description,
                    'user_city' => $user_city,
                );
            }
            if (!empty($username) && !empty($network)) {
                $update_fields = '';
                if (isset($this->users_cache[$username])) {
                    $user = $this->users_cache[$username];
                    if ($user_avatar != '' && $user_avatar != $user->avatar_url) {
                        $update_fields.="`avatar_url`='" . addslashes($user_avatar) . "',";
                    }
                    if ($user_description != '' && $user_description != $user->user_description) {
                        $update_fields.="`user_description`='" . addslashes($user_description) . "',";
                    }
                    if ($user_city != '' && $user_city != $user->user_city) {
                        $update_fields.="`user_city`='" . addslashes($user_city) . "',";
                    }
                    //If no changes, then retrun existing user
                    if ($update_fields == '') {
                        return $this->users_cache[$username];
                    }
                }

                $req = "SELECT * FROM `" . $this->config['db_prefix'] . "users` WHERE " . $this->db_where() . " `name`='" . addslashes($username) . "' AND `network`='" . addslashes($network) . "' ";
                $res = mysqli_query($this->mysqli, $req);
                if ($res && mysqli_num_rows($res) == 1) {
                    $user = mysqli_fetch_object($res);
                } else {
                    $user = $this->register_user($user_array);
                }

                // UPDATE CHANGED FIELDS
                $update_fields = '';
                if ($user_avatar != '' && $user_avatar != $user->avatar_url) {
                    $update_fields.="`avatar_url`='" . addslashes($user_avatar) . "',";
                }
                if ($user_description != '' && $user_description != $user->user_description) {
                    $update_fields.="`user_description`='" . addslashes($user_description) . "',";
                }
                if ($user_city != '' && $user_city != $user->user_city) {
                    $update_fields.="`user_city`='" . addslashes($user_city) . "',";
                }
                if ($update_fields != '') {
                    $update_fields = substr($update_fields, 0, -1);
                    $req = "UPDATE
					`" . $this->config['db_prefix'] . "users`
				SET
					 " . $update_fields . "
				WHERE
					`id`='" . abs($user->id) . "' ";
                    $res = mysqli_query($this->mysqli, $req);
                    //echo $req;
                    $user = $this->get_user($username, $network);
                }

                $this->users_cache[$username] = $user;
                $this->users_cache_id[$user->id] = $user;
                return $user;
            }
            return false;
        }

        function get_user_by_id($userid) {
            if (!$this->session)
                return false;
            if (isset($this->users_cache_id[$userid]))
                return $this->users_cache_id[$userid];

            $req = "SELECT * FROM `" . $this->config['db_prefix'] . "users` WHERE " . $this->db_where() . " `id`='" . addslashes($userid) . "'";
            $res = mysqli_query($this->mysqli, $req);
            if ($res && mysqli_num_rows($res) == 1) {
                $user = mysqli_fetch_object($res);
                $this->users_cache[$user->name] = $user;
                $this->users_cache_id[$userid] = $user;
                return $user;
            }
            return false;
        }

        function is_valid_user($username, $network) {
            if (!$this->session)
                return false;
            if (false !== $user = $this->get_user($username, $network)) {
                return $user->status == 1;
            }
            return false;
        }

        function register_user($username, $network = '', $user_avatar = '', $user_description = '', $user_city = '') {
            if (!$this->session)
                return false;

            //echo $username.' / '.$network.' / '.$user_avatar."\n\n";
            if (is_array($username)) {
                $user_array = $username;
                $username = isset($user_array['username']) ? $user_array['username'] : '';
                $network = isset($user_array['network']) ? $user_array['network'] : '';
                $user_avatar = isset($user_array['user_avatar']) ? $user_array['user_avatar'] : '';
                $user_description = isset($user_array['user_description']) ? $user_array['user_description'] : '';
                $user_city = isset($user_array['user_city']) ? $user_array['user_city'] : '';
            }
            $username=  strip_tags($username);
            if (!empty($username) && !empty($network)) {
                if (isset($this->users_cache[$username]))
                    return $this->users_cache[$username];
                $req = "INSERT INTO
				`" . $this->config['db_prefix'] . "users`
				(`session_id`,`name`,`network`,`avatar_url`,`user_description`,`user_city`,`status`)
			VALUES
				('" . $this->session->id . "','" . addslashes($username) . "','" . addslashes($network) . "','" . addslashes($user_avatar) . "','" . addslashes($user_description) . "','" . addslashes($user_city) . "',1) ";
                if (mysqli_query($this->mysqli, $req)) {
                    return $this->get_user($username, $network);
                }
            }
            return false;
        }

        function list_users($param = array()) {
            if (!$this->session)
                return false;
            if (!is_array($param)) {
                $param = array();
            }
            $default = array(
                'network' => '',
                'status' => '',
                'minid' => '',
                'maxid' => '',
                'order' => 'DESC',
                'order_by' => 'id',
                'per_page' => '5',
                'page' => '1'
            );

            foreach ($default as $k => $v) {
                if (isset($param[$k])) {
                    $param[$k] = $this->mysqli->real_escape_string($param[$k]);
                } else {
                    $param[$k] = $default[$k];
                }
            }

            $req = "SELECT * FROM `" . $this->config['db_prefix'] . "users` WHERE " . $this->db_where() . " 1 ";
            if (!empty($param['user_id'])) {
                $req.=" AND `id`='" . $param['item_id'] . "'";
            } else {
                if (!empty($param['network'])) {
                    $req.=" AND `network`='" . $param['network'] . "'";
                }
                if (!empty($param['status'])) {
                    $req.=" AND `status`='" . $param['status'] . "'";
                }

                if (!empty($param['minid'])) {
                    $req.=" AND `id`>'" . $param['minid'] . "'";
                }
                if (!empty($param['maxid'])) {
                    $req.=" AND `id`<'" . $param['maxid'] . "'";
                }

                if (!empty($param['order']) && !empty($param['order_by'])) {
                    $req.=" ORDER BY `" . $param['order_by'] . "`" . ($param['order'] == 'DESC' ? 'DESC' : 'ASC');
                }

                if (is_numeric($param['per_page']) && is_numeric($param['page']) && $param['per_page'] > 0 && $param['page'] > 0) {
                    $req.=" LIMIT " . (($param['page'] - 1) * $param['per_page']) . "," . $param['per_page'];
                }
            }
            $ret = array();
            if ($res = mysqli_query($this->mysqli, $req)) {
                while ($user = mysqli_fetch_object($res)) {
                    $ret[] = $user;
                }
            }
            return $ret;
        }

        /** Posts * */
        function add($content, $username = '', $network = '', $pub_id = '', $url = '', $date = '', $media_url = '', $pub_lat = '', $pub_lon = '', $user_avatar = '', $user_description = '', $user_city = '', $expanded_url = '') {
            if (empty($username) && is_array($content)) {
                $default = array(
                    'text' => '',
                    'username' => '',
                    'network' => '',
                    'pub_id' => '',
                    'url' => '',
                    'date' => '',
                    'media_url' => '',
                    'expanded_url' => '',
                    'pub_lat' => '',
                    'pub_lon' => '',
                    'user_avatar' => '',
                    'user_description' => '',
                    'user_city' => '',
                    'search' => ''
                );
                $params = $content;
                //print_r($params);
                foreach ($default as $k => $v) {
                    if (isset($params[$k])) {
                        $$k = $params[$k];
                    } else {
                        $$k = '';
                    }
                }
            } else {
                $text = $content;
            }

            //echo'-';
            if (empty($username) || empty($network))
                return false;
            if (!$this->session)
                return false;
            $text=strip_tags($text);
            //echo($text);
            if ((!empty($text) || !empty($media_url)) && !empty($username) && !empty($network) && !empty($pub_id)) {
                global $conn;
                if (false !== $user = $this->get_user(array(
                    'username' => $username,
                    'network' => $network,
                    'user_avatar' => $user_avatar,
                    'user_description' => $user_description,
                    'user_city' => $user_city
                        ))) {
                    $req = "SELECT
						`content`
					FROM
						`" . $this->config['db_prefix'] . "items`
					WHERE
						" . $this->db_where() . "
						`content`='" . addslashes($text) . "'
						AND `media_url`='" . addslashes($media_url) . "'
						 ";
                    if (isset($_GET['debug'])) {
                        //print_r($params);
                        //echo $req;
                    }
                    $res = mysqli_query($this->mysqli, $req);
                    if ($this->session->duplicate === 0 && ($res != false && mysqli_num_rows($res) > 0)) {
                        return false;
                    }
                    $req = "INSERT INTO `" . $this->config['db_prefix'] . "items`
						(`session_id`,`user_id`, `network`, `pub_date`, `pub_url`,`pub_id`, `pub_lat`, `pub_lon`, `content`,`media_url`,`expanded_url`, `status`,`search`)
					VALUES (
						'" . $this->session->id . "',
						'" . $user->id . "',
						'" . addslashes($network) . "',
						'" . (!empty($date) ? date('Y-m-d H:i:s', strtotime($date)) : 'NOW()') . "',
						'" . addslashes($url) . "',
						'" . addslashes($pub_id) . "',
						'" . addslashes($pub_lat) . "',
						'" . addslashes($pub_lon) . "',
						'" . addslashes($text) . "',
						'" . addslashes($media_url) . "',
						'" . addslashes($expanded_url) . "',
						'" . ($this->session->mod<=$user->status?1:0) . "',
						'" . addslashes($search)  . "'
						) ";

                    //echo $req;
                    if (mysqli_query($this->mysqli, $req)) {
                        return mysqli_insert_id($conn);
                    }
                    return mysqli_error($conn);
                }
                return false;
            }
            return false;
        }

        function get($param = array()) {
            if (!$this->session)
                return false;
            if (!is_array($param)) {
                $param = array();
            }
            $default = array(
                'network' => '',
                'username' => '',
                'status' => '1',
                'after' => '',
                'before' => '',
                'minid' => '',
                'maxid' => '',
                'pub_id' => '',
                'item_id' => '',
                'order' => 'DESC',
                'order_by' => 'pub_date',
                'per_page' => '5',
                'page' => '1',
                'i' => ''
            );

            foreach ($default as $k => $v) {
                if (isset($param[$k])) {
                    $param[$k] = $this->mysqli->real_escape_string($param[$k]);
                } else {
                    $param[$k] = $default[$k];
                }
            }

            $req = "SELECT * FROM `" . $this->config['db_prefix'] . "items` WHERE " . $this->db_where() . " 1 ";
            if (!empty($param['item_id'])) {
                $req.=" AND `id`='" . $param['item_id'] . "'";
            } else {
                if (!empty($param['network'])) {
                    $req.=" AND `network`='" . $param['network'] . "'";
                }
                if (!empty($param['username']) && !empty($param['network'])) {
                    if (false !== $user = $this->get_user($param['username'], $param['network'])) {
                        $req.=" AND `user_id`='" . $user->id . "'";
                    }
                }
                if (!empty($param['status'])) {
                    $req.=" AND `status`>='" . $param['status'] . "'";
                }

                if (!empty($param['after'])) {
                    $req.=" AND `pub_date`>='" . date('Y-m-d H:i:s', strtotime($param['after'])) . "'";
                }
                if (!empty($param['before'])) {
                    $req.=" AND `pub_date`<='" . date('Y-m-d H:i:s', strtotime($param['before'])) . "'";
                }
                if (!empty($param['pub_id'])) {
                    $req.=" AND `pub_id`='" . $param['pub_id'] . "'";
                }

                if (!empty($param['minid'])) {
                    $req.=" AND `id`>'" . $param['minid'] . "'";
                }
                if (!empty($param['maxid'])) {
                    $req.=" AND `id`<'" . $param['maxid'] . "'";
                }

                if (!empty($param['order']) && !empty($param['order_by'])) {
                    $req.=" ORDER BY `" . $param['order_by'] . "`" . ($param['order'] == 'DESC' ? 'DESC' : 'ASC');
                }
                if (is_numeric($param['i'])) {
                    $req.=" LIMIT " . $param['i'] . ",1";
                } elseif (is_numeric($param['per_page']) && is_numeric($param['page']) && $param['per_page'] > 0 && $param['page'] > 0) {
                    $req.=" LIMIT " . (($param['page'] - 1) * $param['per_page']) . "," . $param['per_page'];
                }
            }
            if (isset($_GET['debug'])) {
                print_r($param);
                echo $req;
            }
            //echo $req;
            $ret = array();
            if ($res = mysqli_query($this->mysqli, $req)) {
                while ($item = mysqli_fetch_object($res)) {
                    if(!json_encode($item->content)){
                        $item->content = utf8_encode($item->content);
                    }
                    $item->user = $this->get_user_by_id($item->user_id);
                    $item->timestamp = strtotime($item->pub_date);
                    $ret[] = $item;
                }
            }
            return $ret;
        }

        function mention_detect($content, $network) {
            $content = str_replace('@', ' @', $content);
            preg_match_all('#[\n\t\r\s  \: \.]@([a-zA-Z0-9_]+)[\n\t\r\s\:\.\/,  \?; ]#i', ' ' . $content . ' ', $array, PREG_PATTERN_ORDER);
            if (is_array($array)) {
                foreach ($array[1] as $mention) {
                    $html = ' <span class="mention">';
                    if (false !== $user = $this->get_user($mention, $network)) {
                        if (!empty($user->avatar_url)) {
                            $html.='<img src="' . $user->avatar_url . '">';
                        }
                    }
                    $html.=' @' . $mention . '</span>';
                    $content = str_replace('@' . $mention, $html, $content);
                }
            }
            return $content;
        }

        function hashtag_detect($content) {
            $content = str_replace('#', ' #', $content);
            preg_match_all('#[\n\t\r\s  \: \.]\#([a-zA-Z0-9_]+)[\n\t\r\s\:\.\/,  \?; ]#i', ' ' . $content . ' ', $array, PREG_PATTERN_ORDER);
            if (is_array($array)) {
                foreach ($array[1] as $hastag) {
                    $html = ' <span class="hashtag">';
                    $html.='#' . $hastag . '</span>';
                    $content = str_replace('#' . $hastag, $html, $content);
                }
            }
            return $content;
        }

        function url_detect($content) {
            $content = str_replace('http', ' http', $content);
            preg_match_all('#[\n\t\r\s\: ]https?://([a-zA-Z0-9_\?\&\-\/\.\:]+)[\n\t\r\s ]#i', ' ' . $content . ' ', $array, PREG_PATTERN_ORDER);
            if (is_array($array)) {
                foreach ($array[1] as $url) {
                    $html = ' <span class="url">';
                    $html.='' . $url . '</span>';
                    $content = str_replace(array('http://' . $url, 'https://' . $url), $html, $content);
                }
            }
            return $content;
        }

        /** Moderation * */
        function moderate_item($item_id, $mod = 0) {
            if (!$this->session)
                return false;
            $req = "UPDATE `" . $this->config['db_prefix'] . "items` SET `status`='" . $mod . "' WHERE " . $this->db_where() . " `id`='" . $item_id . "'";
            if (mysqli_query($this->mysqli, $req)) {
                return true;
            }
            return false;
        }

        function moderate_user($user_id, $mod = 0, $recursive = 0) {
            if (!$this->session)
                return false;
            $req = "UPDATE `" . $this->config['db_prefix'] . "users` SET `status`='" . $mod . "' WHERE " . $this->db_where() . " `id`='" . $user_id . "'";
            if ($recursive == 1 && ($mod == 0||$mod==2)) {
                if (mysqli_query($this->mysqli, $req)) {
                    $req = "UPDATE `" . $this->config['db_prefix'] . "items` SET `status`='" . $mod . "' WHERE " . $this->db_where() . " `user_id`='" . $user_id . "'";
                    if (mysqli_query($this->mysqli, $req)) {
                        return true;
                    }
                    echo'bof... ' . $req;
                }
                return false;
            }
            if (mysqli_query($this->mysqli, $req)) {
                return true;
            }
            return true;
        }

        /** Deletion * */
        function del_item($item_id) {
            if (!$this->session)
                return false;
            $req = "DELETE FROM `" . $this->config['db_prefix'] . "items` WHERE " . $this->db_where() . " `id`='" . $item_id . "'";
            if (mysqli_query($this->mysqli, $req)) {
                return true;
            }
            return false;
        }

        function del_user($user_id, $recursive = 0) {
            if (!$this->session)
                return false;
            $req = "DELETE FROM `" . $this->config['db_prefix'] . "users` WHERE " . $this->db_where() . " `id`='" . $user_id . "'";
            if ($recursive == 1) {
                if (mysqli_query($this->mysqli, $req)) {
                    $req = "DELETE FROM `" . $this->config['db_prefix'] . "items` WHERE " . $this->db_where() . " `user_id`='" . $user_id . "'";
                    if (mysqli_query($this->mysqli, $req)) {
                        return true;
                    }
                    echo'bof... ' . $req;
                }
                return false;
            }
            if (mysqli_query($this->mysqli, $req)) {
                return true;
            }
            return true;
        }

        /* If called from front :
         * make session rotate
         */

        function front() {

            $rotate = 0;
            $current_path = substr($_SERVER['REQUEST_URI'], strlen($this->config['base_path']));
            if (empty($current_path)) {

            } else {
                $vars = explode('/', $current_path . '/');
                $name = isset($vars[0]) ? str_replace('.rss', '', $vars[0]) : '';
                if (!empty($name)) {
                    $req = "SELECT * FROM `" . $this->config['db_prefix'] . "sessions` WHERE `name`='" . addslashes($name) . "' ";
                    if (false !== ($res = mysqli_query($this->mysqli, $req)) && mysqli_num_rows($res) == 1) {
                        $row = mysqli_fetch_object($res);
                        $this->session = $row;
                        $this->title = $row->name . ' : ' . $this->title;
                        $this->template = isset($vars[1]) && in_array($vars[1], $this->templates) ? $vars[1] : 'slide';

                        $req = "SELECT COUNT(`id`) FROM `" . $this->config['db_prefix'] . "items` WHERE `session_id`='" . $this->session->id . "' AND `status`=1";
                        if (false !== ($res = mysqli_query($this->mysqli, $req)) && mysqli_num_rows($res) == 1) {
                            $row = mysqli_fetch_array($res);
                            $rotate = $row[0] >= 10 ? 10 : $row[0] - 1;
                        }
                    }
                }
            }

            if (!isset($_SESSION['eg_i'])) {
                $_SESSION['eg_i'] = $rotate;
            } else {
                $_SESSION['eg_i'] --;
                if ($_SESSION['eg_i'] < 0) {
                    $_SESSION['eg_i'] = $rotate;
                }
            }
        }

        function styles() {
            ?>
            <link rel="stylesheet" href="<?= $this->config['base_path'] ?>ecologram.css" />
            <link href='//fonts.googleapis.com/css?family=Roboto:100,300,500,700,900,400|Roboto+Slab:400,100,700,300|Roboto+Condensed:400,700,300' rel='stylesheet' type='text/css'>
            <?php
        }

        function scripts() {
            ?>
            <script src="http://code.jquery.com/jquery-1.11.0.min.js"></script>
            <script type="text/javascript">var eg = {base_path: '<?= $this->config['base_path'] ?>', refresh_delay: '<?= $this->config['refresh_delay'] ?>'};</script>
            <?php if ($this->template != 'main'): ?>
                <script src="<?= $this->config['base_path'] ?>ecologram.js"></script>
            <?php
            endif;
        }

        function admin_scripts() {
            $eg_admin  = array(
                'session'=>$this->session,
                'net'=>$this->networks,
                'server'=>array(
                    'name'=>$this->server_name,
                    'protocol'=>$this->server_protocol
                ),
                'strings'=>array(
                    'User details'=>  utf8_encode(__('User details'))
                )
            )
            ?>

            <script type="text/javascript">
                var eg_admin = <?php echo json_encode($eg_admin) ?>;
                var current_page='admin';
            </script>
            <?php $this->scripts(); ?>
            <script src="//code.jquery.com/ui/1.10.4/jquery-ui.js"></script>
            <script src="//cdn.rawgit.com/noelboss/featherlight/master/release/featherlight.min.js" type="text/javascript" charset="utf-8"></script>
            <script src="<?= $this->base_url ?>php.js"></script>
            <script src="ecologram.js"></script>
            <?php
            if (basename($_SERVER['SCRIPT_NAME']) == 'index.php' || basename($_SERVER['SCRIPT_NAME']) == 'networks.php') {
                foreach ($this->networks as $network => $attr) {
                    if (is_file($this->networks_path . $network . '/' . $network . '.js')) {
                        ?>
                        <script src="<?= $this->config['base_path'] . 'includes/networks/' . $network . '/' . $network ?>.js"></script>
                    <?php
                    }
                }
            }
        }

        function template() {
            $include = ABS_PATH . 'templates/' . $this->template . '.php';
            if (file_exists($include)) {
                include($include);
            }
        }

    }

    $eg = new ecologram();
}

